'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _reactVendorPrefix = require('react-vendor-prefix');

var _reactVendorPrefix2 = _interopRequireDefault(_reactVendorPrefix);

var Layout = _reactAddons2['default'].createClass({
    displayName: 'Layout',

    propTypes: {
        type: _reactAddons2['default'].PropTypes.string.isRequired
    },

    getDefaultProps: function getDefaultProps() {
        return {
            type: 'columns'
        };
    },

    render: function render() {
        var classes = ['Layout'];
        if (this.props.className) {
            classes.push(this.props.className);
        }
        classes.push(this.props.type);

        var style = undefined;

        if (this.props.type === 'rows') {
            style = {
                display: 'flex',
                flex: 1,
                flexDirection: 'column',

                //position: 'relative',
                //height: '100%',
                //minHeight: '100%'

                //width: '100%',
                position: 'absolute',
                left: 0,
                right: 0,

                top: 0,
                bottom: 0
            };
        } else {
            style = {
                display: 'flex',
                flex: 1,
                flexDirection: 'row',

                //height: '100%',
                position: 'absolute',
                left: 0,
                right: 0,

                top: 0,
                bottom: 0

            };
        }

        var prefixed = _reactVendorPrefix2['default'].prefix({ styles: style });

        var type = this.props.type;
        var index = 0;
        var elements = [];
        if (this.props.children) {
            elements = this.props.children.map(function (child) {
                return _reactAddons2['default'].addons.cloneWithProps(child, {
                    type: type,
                    key: index++
                });
            });
        }

        return _reactAddons2['default'].createElement(
            'div',
            { className: classes.join(' '), style: prefixed.styles },
            elements
        );
    }
});

exports['default'] = Layout;
module.exports = exports['default'];